Wt: Wt::WItemSelectionModel Class Reference

Wt 3.3.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Hierarchy
- Class Members

Public Member Functions
Wt::WItemSelectionModel Class Reference
Model/view system

A class that represents a selection for a WAbstractItemView. More...

`#include <Wt/WItemSelectionModel>`

Inheritance diagram for Wt::WItemSelectionModel:
[legend]

List of all members.

## Public Member Functions
WAbstractItemModel * | model () const
| Returns the WAbstractItemModel.
WModelIndexSet | selectedIndexes () const
| Returns the set of selected items.
bool | isSelected (const WModelIndex &index) const
| Returns wheter an item is selected.
void | setSelectionBehavior (SelectionBehavior behavior)
| Sets the selection behaviour.
SelectionBehavior | selectionBehavior () const
| Returns the selection behaviour.
virtual std::string | mimeType ()
| Returns the selection mime type.

## Detailed Description

A class that represents a selection for a WAbstractItemView.

This model is currently only used by WTreeView, and plays only a role in drag & drop of an item selection.

When an item selection is dragged from a view widget, the generated drop events will have as source object (see WDropEvent::source()) this selection model.

Although this class does not (yet) allow you to modify the selection, note that manipulations to the model may modify the selection (row insertions and removals may shift the selection, and row deletions may shrink the selection).

Note:
  Currently this class cannot be shared between multiple views.

See also:
  WTreeView, WTableView, WAbstractItemModel

## Member Function Documentation

bool Wt::WItemSelectionModel::isSelected | ( | const WModelIndex & | index | ) | const

Returns wheter an item is selected.

When selection operates on rows (SelectRows), this method returns true for each element in a selected row.

See also:
  selectedIndexes()

std::string Wt::WItemSelectionModel::mimeType | ( |  | ) | `[virtual]`

Returns the selection mime type.

This should return the mime type for the current selection, or an emtpy string if the selection cannot be dragged.

The default implementation returns the mime type based on MimeTypeRole data if all selected items indicate the same mime type, or the model mimeType() otherwise.

If one or more items indicate that they cannot be dragged, then an empty string is returned.

WModelIndexSet Wt::WItemSelectionModel::selectedIndexes | ( |  | ) | const

Returns the set of selected items.

The model indexes are returned as a set, topologically ordered (in the order they appear in the view).

When selection operates on rows (SelectRows), this method only returns the model index of first column's element of the selected rows.

SelectionBehavior Wt::WItemSelectionModel::selectionBehavior | ( |  | ) | const

Returns the selection behaviour.

See also:
  setSelectionBehavior()

void Wt::WItemSelectionModel::setSelectionBehavior | ( | SelectionBehavior | behavior | ) |

Sets the selection behaviour.

By default, the selection contains rows (SelectRows), in which case model indexes will always be have column 0, but represent the whole row.

Alternatively, you can allow selection for individual items (SelectItems).

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator